// TriState button class definition,  describes button with three states
// Copyright (C) 29.08.97 Marco Dettori and Oliver Obst
//
// $Id: tristate.h,v 0.2 1998/03/16 10:56:21 oliver Exp $

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

#ifndef TRISTATE_H
#define TRISTATE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qvector.h>
#include <qpushbt.h>
#include <qbrush.h>

class TriState : public QButton
{
        Q_OBJECT
public:
        TriState(QWidget *parent=0);
        TriState(const QColor &color, QWidget *parent=0);
        
        virtual ~TriState();

        enum    State   { EMPTY, CROSS, CIRCLE };
        
        void    setState( State s );
        State   getState();
        
        void    setBackgroundColor( const QColor &color );

        void    visit( bool b = TRUE );
        bool    visited();

protected:
        void    drawButton( QPainter * );
        void    setColorGroup( const QColor &color );

private:        
        State           state;
        QColorGroup     colors;
        QBrush          fill;
        bool            seen;
};

typedef QVector<TriState>       TriStates;

#endif TRISTATE_H
