// Shipkill Server
// Copyright (C) 04.09.97 Marco Dettori and Oliver Obst

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <strings.h>
#include <stdlib.h>

#include <iostream.h>
#include <netdb.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <time.h>

#include "protoconst.h"
#include "version.h"

#define _REENTRANT
#define PORT_NR 17003

const bool      TRUE = 1;
const bool      FALSE = 0;
const int       bufsize = 100;

void swap( int *x1, int *x2 );
bool serverloop( int *socket, int *i, int *j );


int main(void)
{

        struct sockaddr_in      cli_addr, serv_addr;
        int			clifd[ 2 ], sockfd, pid, i0, i1, p0, p1;
        char                    player0[ 200 ], player1[ 200 ];
        bool                    play;
        
        int                     addrlen = sizeof( sockaddr_in );

        

        cout << Versiontxt << "\n"
             << Copyright << "\n";

        srand( time( NULL ) );        // init random number generator

// einen Socket erzeugen (Typ: Internet/Stream => TCP)

        if ( ( sockfd = socket( AF_INET, SOCK_STREAM, 0 ) ) < 0 ) {
                cerr << "Server kann den Socket nicht erzeugen.\n";
                exit(-1);
        }

// bind ausfhren

        bzero((char *)&serv_addr, sizeof(serv_addr));     // Struktur l"oschen
        serv_addr.sin_family      = AF_INET;
        serv_addr.sin_addr.s_addr = INADDR_ANY;
        serv_addr.sin_port        = htons( u_short( PORT_NR ) );

        if ( bind( sockfd, (struct sockaddr *) &serv_addr,
                   sizeof( serv_addr ) ) < 0) {
            cerr << "Server kann keine Adresse an das Socket binden!\n ";
            exit(-1);
        }


// listen ausf"uhren, max. 5 in der Warteschlange

        listen(sockfd, 5);


// wartet auf eine Anfrage eines Clients
// schleift unendlich


        for( ; ; )
        {
                play = TRUE;
                
                clifd[ 0 ] = accept( sockfd,
                                     (struct sockaddr *) &cli_addr, &addrlen );
	
                if ( clifd[ 0 ] < 0 ) {
                        cerr << "Server hat Fehler bei Accept!\n";
                        play = FALSE;
                } else {
                        clifd[ 1 ] = accept( sockfd,
                                             (struct sockaddr *) &cli_addr,
                                             &addrlen );

                        if ( clifd[ 1 ] < 0 ) {
                                cerr << "Server hat Fehler bei Accept!\n";
                                play = FALSE;
                        }
                }

                
                if ((pid = fork()) < 0) {
                        cerr << "Cannot fork!\n";
                        cerr << "Server terminated.\n";
                        exit(-1);
                }	
	
                if ( play && pid == 0 ) {            // Kind-Prozess
                        close(sockfd);

                        if ( rand() % 2 == 0 ) {
                                i0 = 0;
                                i1 = 1;
                        } else {
                                i0 = 1;
                                i1 = 0;
                        }

                        p0 = read( clifd[ i0 ], player0, 200 );
                        p1 = read( clifd[ i1 ], player1, 200 );

                        player0[ p0++ ] = player1[ p1++ ] = 0xFF;
                        player0[ p0++ ] = ETX;
                        player1[ p1++ ] = ETB;

                        if ( write( clifd[ i0 ], player1, p1 ) != p1 ) {
                                cerr << "Schreibfehler (Startsignal).\n";
                                play = FALSE;
                        }

                        if ( write( clifd[ i1 ], player0, p0 ) != p0 ) {
                                cerr << "Schreibfehler (Startsignal).\n";
                                play = FALSE;
                        }
                        

                        while ( play ) {
                                play = serverloop( clifd, &i0, &i1 );
                        }
                        
                        close( clifd[ 0 ] );
                        close( clifd[ 1 ] );
                        exit(0);
                } else {
                        close(clifd[ 0 ]);
                        close(clifd[ 1 ]);
                        
                }
        }
}

                

void swap( int *x1, int *x2 ) 
{
        int     h;

        h       = *x2;
        *x2      = *x1;
        *x1      = h;
}
 

bool serverloop( int *socket, int *i, int *j )
{
        char    buffer[ bufsize ];
        int     n, m;
        bool    loop = TRUE;

        n = read( socket[ *i ], buffer, bufsize );
        m = write( socket[ *j ], buffer, n );

        if ( n == 0 || n != m )
            loop = FALSE;
        else {
                if ( buffer[ n - 2 ] == char(0xFF) && buffer[ n - 1 ] == ETB )
                        swap( i, j );
                if ( buffer[ n - 2 ] == char(0xFF) && buffer[ n - 1 ] == EOT ){
                        loop = FALSE;
                        close( socket[ *i ] );
                        read( socket[ *j ], buffer, 100 );
                        close( socket[ *j ] );
                }
        }

        return loop;
}
